/****************************************************************
-- BACKUP --
We're going to solve enterprise* backup issues/needs today, using 
Minion Backup as the platform. Of course, you can use something 
else to solve these same problems.

(*Not necessarily SQL Server Enterprise edition...I mean "your shop.")

****************************************************************/


--*-- Setup stuff, just in case:
----CREATE DATABASE MBDemo;
----GO
----TRUNCATE TABLE Minion.BackupLog
----TRUNCATE TABLE Minion.BackupLogDetails
----TRUNCATE TABLE Minion.BackupFiles


USE PRECONDBMaint;
GO


---Here is the primary settings table:
SELECT * FROM Minion.BackupSettings;

EXEC Minion.HELP 'backup','Minion.BackupSettings'


------------------------------------------------------------------------------------------															          
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Exclude DBs----------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: We have just a couple of databases that should NEVER be backed up. OR,
--*-- there are a couple of databases that should NEVER get a certain kind of backup.

-- A prime example is databases involved in log shipping; if we're not using log backups
-- from THIS process, then exclude log backups for those log shipped DBs!!

-------------------------------------------------
-------------BEGIN All---------------------------
-------------------------------------------------
INSERT INTO Minion.BackupSettings ([DBName], [Port], [BackupType], [Exclude], [GroupOrder], [GroupDBOrder], [Mirror], [DelFileBefore], [DelFileBeforeAgree], [LogLoc], [HistRetDays], [MinionTriggerPath], [DBPreCode], [DBPostCode], [PushToMinion], [DynamicTuning], [Verify], [PreferredServer], [ShrinkLogOnLogBackup], [ShrinkLogThresholdInMB], [ShrinkLogSizeInMB], [MinSizeForDiffInGB], [DiffReplaceAction], [LogProgress], [FileAction], [FileActionTime], [Encrypt], [Name], [ExpireDateInHrs], [RetainDays], [Descr], [Checksum], [Init], [Format], [CopyOnly], [Skip], [BackupErrorMgmt], [MediaName], [MediaDescription], [IsActive], [Comment]) 
SELECT 'Latin1_General_BIN' AS [DBName], NULL AS [Port], 'All' AS [BackupType], 0 AS [Exclude], 8 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment]

UPDATE Minion.BackupSettings 
SET Exclude = 1
WHERE DBName = 'Latin1_General_BIN' AND BackupType = 'All'

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Log', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0

-------------------------------------------------
-------------END All-----------------------------
-------------------------------------------------

SELECT * FROM Minion.BackupSettings;

-------------------------------------------------
-------------BEGIN Full--------------------------
-------------------------------------------------
INSERT INTO Minion.BackupSettings ([DBName], [Port], [BackupType], [Exclude], [GroupOrder], [GroupDBOrder], [Mirror], [DelFileBefore], [DelFileBeforeAgree], [LogLoc], [HistRetDays], [MinionTriggerPath], [DBPreCode], [DBPostCode], [PushToMinion], [DynamicTuning], [Verify], [PreferredServer], [ShrinkLogOnLogBackup], [ShrinkLogThresholdInMB], [ShrinkLogSizeInMB], [MinSizeForDiffInGB], [DiffReplaceAction], [LogProgress], [FileAction], [FileActionTime], [Encrypt], [Name], [ExpireDateInHrs], [RetainDays], [Descr], [Checksum], [Init], [Format], [CopyOnly], [Skip], [BackupErrorMgmt], [MediaName], [MediaDescription], [IsActive], [Comment]) 
SELECT 'TDEBackupTest' AS [DBName], NULL AS [Port], 'All' AS [BackupType], 0 AS [Exclude], 8 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment]
UNION
SELECT 'TDEBackupTest' AS [DBName], NULL AS [Port], 'Full' AS [BackupType], 0 AS [Exclude], 8 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment];


UPDATE Minion.BackupSettings 
SET Exclude = 1
WHERE DBName = 'TDEBackupTest' AND BackupType = 'Full';

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0

--The "Log" BackupDB statement should show up here; if it doesn't show up here take an initial full.
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Log', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0
		---- EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'TDEBackupTest', @Exclude = NULL, @ReadOnly = 1, @Debug = 0
		
-------------------------------------------------
-------------END Full----------------------------
-------------------------------------------------


SELECT * FROM Minion.BackupSettings;


-------------------------------------------------
-------------BEGIN Log---------------------------
-------------------------------------------------

-------Change the backup type to exclude logs instead.
UPDATE Minion.BackupSettings 
SET BackupType = 'Log'
WHERE DBName = 'TDEBackupTest' AND BackupType = 'Full'

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0
--Now TDEBackupTest should NOT show up for log backups:
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Log', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0


--!-- IMPORTANT: If that "All" row wsn't there, we would have no setting for TDEBackupTest/Full, 
--!-- and we wouldn't get TDEBackupTest/Full backups! ** Always cover all backup types for a database. ***


/*
	Side note: do SIMPLE DBs get log backup commands? NO! 

	SELECT * FROM sys.databases 
	WHERE recovery_model_desc = 'SIMPLE'
	ORDER BY name; -- DIYPerfReporting is in SIMPLE mode!

	EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Log', @StmtOnly = 1, @Include = 'DIYPerfReporting', @Exclude = NULL, @ReadOnly = 1, @Debug = 0
*/


-------------------------------------------------
-------------END Log-----------------------------
-------------------------------------------------

---------------------------------------------Reset.
DELETE FROM Minion.BackupSettings WHERE DBName <> 'MinionDefault'
SELECT * FROM Minion.BackupSettings;

------------------------------------------------------------------------------------------															          
------------------------------------------------------------------------------------------
-------------------------------- END Exclude DBs------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------															          
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Order DBs------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: I have some VERY IMPORTANT databases that need to be backed up first!
--*-- Let's order the backups.

-- One example would be if you have one database as part of a time dependent process - like,
-- DB1 has to be backed up in time for the datacenter restore a couple of hours later.

-------------------------------------------------
-------------BEGIN All---------------------------
-------------------------------------------------
INSERT INTO Minion.BackupSettings ([DBName], [Port], [BackupType], [Exclude], [GroupOrder], [GroupDBOrder], [Mirror], [DelFileBefore], [DelFileBeforeAgree], [LogLoc], [HistRetDays], [MinionTriggerPath], [DBPreCode], [DBPostCode], [PushToMinion], [DynamicTuning], [Verify], [PreferredServer], [ShrinkLogOnLogBackup], [ShrinkLogThresholdInMB], [ShrinkLogSizeInMB], [MinSizeForDiffInGB], [DiffReplaceAction], [LogProgress], [FileAction], [FileActionTime], [Encrypt], [Name], [ExpireDateInHrs], [RetainDays], [Descr], [Checksum], [Init], [Format], [CopyOnly], [Skip], [BackupErrorMgmt], [MediaName], [MediaDescription], [IsActive], [Comment]) 
SELECT 'MinionInstall' AS [DBName], NULL AS [Port], 'All' AS [BackupType], 0 AS [Exclude], 10 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment]
INSERT INTO Minion.BackupSettings ([DBName], [Port], [BackupType], [Exclude], [GroupOrder], [GroupDBOrder], [Mirror], [DelFileBefore], [DelFileBeforeAgree], [LogLoc], [HistRetDays], [MinionTriggerPath], [DBPreCode], [DBPostCode], [PushToMinion], [DynamicTuning], [Verify], [PreferredServer], [ShrinkLogOnLogBackup], [ShrinkLogThresholdInMB], [ShrinkLogSizeInMB], [MinSizeForDiffInGB], [DiffReplaceAction], [LogProgress], [FileAction], [FileActionTime], [Encrypt], [Name], [ExpireDateInHrs], [RetainDays], [Descr], [Checksum], [Init], [Format], [CopyOnly], [Skip], [BackupErrorMgmt], [MediaName], [MediaDescription], [IsActive], [Comment]) 
SELECT 'TDEBackupTest' AS [DBName], NULL AS [Port], 'All' AS [BackupType], 0 AS [Exclude], 9 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment]
INSERT INTO Minion.BackupSettings ([DBName], [Port], [BackupType], [Exclude], [GroupOrder], [GroupDBOrder], [Mirror], [DelFileBefore], [DelFileBeforeAgree], [LogLoc], [HistRetDays], [MinionTriggerPath], [DBPreCode], [DBPostCode], [PushToMinion], [DynamicTuning], [Verify], [PreferredServer], [ShrinkLogOnLogBackup], [ShrinkLogThresholdInMB], [ShrinkLogSizeInMB], [MinSizeForDiffInGB], [DiffReplaceAction], [LogProgress], [FileAction], [FileActionTime], [Encrypt], [Name], [ExpireDateInHrs], [RetainDays], [Descr], [Checksum], [Init], [Format], [CopyOnly], [Skip], [BackupErrorMgmt], [MediaName], [MediaDescription], [IsActive], [Comment]) 
SELECT 'DIYPerfReporting' AS [DBName], NULL AS [Port], 'All' AS [BackupType], 0 AS [Exclude], 8 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment]

SELECT * FROM Minion.BackupSettings;

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0

----This one may not have all DBs in it because they may not all have initial fulls.
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Log', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0

/*
	Wait, why didn't we get DIYPerfReporting third in line for log backups??

	SELECT recovery_model_desc, * FROM sys.databases WHERE name='DIYPerfReporting'
*/

-------------------------------------------------
-------------END All-----------------------------
-------------------------------------------------


-------------------------------------------------
-------------BEGIN Log---------------------------
-------------------------------------------------
INSERT INTO Minion.BackupSettings ([DBName], [Port], [BackupType], [Exclude], [GroupOrder], [GroupDBOrder], [Mirror], [DelFileBefore], [DelFileBeforeAgree], [LogLoc], [HistRetDays], [MinionTriggerPath], [DBPreCode], [DBPostCode], [PushToMinion], [DynamicTuning], [Verify], [PreferredServer], [ShrinkLogOnLogBackup], [ShrinkLogThresholdInMB], [ShrinkLogSizeInMB], [MinSizeForDiffInGB], [DiffReplaceAction], [LogProgress], [FileAction], [FileActionTime], [Encrypt], [Name], [ExpireDateInHrs], [RetainDays], [Descr], [Checksum], [Init], [Format], [CopyOnly], [Skip], [BackupErrorMgmt], [MediaName], [MediaDescription], [IsActive], [Comment]) 
SELECT 'MinionInstall' AS [DBName], NULL AS [Port], 'Log' AS [BackupType], 0 AS [Exclude], 13 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment]
INSERT INTO Minion.BackupSettings ([DBName], [Port], [BackupType], [Exclude], [GroupOrder], [GroupDBOrder], [Mirror], [DelFileBefore], [DelFileBeforeAgree], [LogLoc], [HistRetDays], [MinionTriggerPath], [DBPreCode], [DBPostCode], [PushToMinion], [DynamicTuning], [Verify], [PreferredServer], [ShrinkLogOnLogBackup], [ShrinkLogThresholdInMB], [ShrinkLogSizeInMB], [MinSizeForDiffInGB], [DiffReplaceAction], [LogProgress], [FileAction], [FileActionTime], [Encrypt], [Name], [ExpireDateInHrs], [RetainDays], [Descr], [Checksum], [Init], [Format], [CopyOnly], [Skip], [BackupErrorMgmt], [MediaName], [MediaDescription], [IsActive], [Comment]) 
SELECT 'TDEBackupTest' AS [DBName], NULL AS [Port], 'Log' AS [BackupType], 0 AS [Exclude], 14 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment]
INSERT INTO Minion.BackupSettings ([DBName], [Port], [BackupType], [Exclude], [GroupOrder], [GroupDBOrder], [Mirror], [DelFileBefore], [DelFileBeforeAgree], [LogLoc], [HistRetDays], [MinionTriggerPath], [DBPreCode], [DBPostCode], [PushToMinion], [DynamicTuning], [Verify], [PreferredServer], [ShrinkLogOnLogBackup], [ShrinkLogThresholdInMB], [ShrinkLogSizeInMB], [MinSizeForDiffInGB], [DiffReplaceAction], [LogProgress], [FileAction], [FileActionTime], [Encrypt], [Name], [ExpireDateInHrs], [RetainDays], [Descr], [Checksum], [Init], [Format], [CopyOnly], [Skip], [BackupErrorMgmt], [MediaName], [MediaDescription], [IsActive], [Comment]) 
SELECT 'DIYPerfReporting' AS [DBName], NULL AS [Port], 'Log' AS [BackupType], 0 AS [Exclude], 15 AS [GroupOrder], 0 AS [GroupDBOrder], 0 AS [Mirror], 0 AS [DelFileBefore], 0 AS [DelFileBeforeAgree], 'Local' AS [LogLoc], 60 AS [HistRetDays], NULL AS [MinionTriggerPath], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [PushToMinion], 1 AS [DynamicTuning], '0' AS [Verify], NULL AS [PreferredServer], 0 AS [ShrinkLogOnLogBackup], NULL AS [ShrinkLogThresholdInMB], NULL AS [ShrinkLogSizeInMB], NULL AS [MinSizeForDiffInGB], NULL AS [DiffReplaceAction], NULL AS [LogProgress], NULL AS [FileAction], NULL AS [FileActionTime], 0 AS [Encrypt], NULL AS [Name], NULL AS [ExpireDateInHrs], NULL AS [RetainDays], NULL AS [Descr], 1 AS [Checksum], 1 AS [Init], 1 AS [Format], NULL AS [CopyOnly], NULL AS [Skip], NULL AS [BackupErrorMgmt], NULL AS [MediaName], NULL AS [MediaDescription], 1 AS [IsActive], NULL AS [Comment]

SELECT  *
FROM    Minion.BackupSettings
WHERE   BackupType = 'Log'
ORDER BY GroupOrder DESC;

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0
----This one may not have all DBs in it because they may not all have initial fulls.
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Log', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0

---------------------------------------------Reset.
DELETE FROM Minion.BackupSettings WHERE ID > 1;
-------------------------------------------------
-------------END Log-----------------------------
-------------------------------------------------
												
															          
-------------------------------------------------
-------------BEGIN Dynamic Log Ordering----------
-------------------------------------------------

-- Let's order log backups by their log usage.  DBs with the most log usage 
-- should be backed up first each time.  So, the ordering must be dynamic.

-- DISCUSSION: You'll probably only want this for a small handful of 
-- DBs on any given server, so I wouldn't bother worrying about having all of the DBs 
-- in the table. So just put the ones you're interested in, and manage them in precode.
-- The example below happens to order ALL log backups; that's another option.
-- There are many other dynamic scenarios you can have.  The point here is that it's all 
-- possible because all you have to do is play with the ordering. You'll see other  
-- scenarios later where we use this same method to get around other dynamic criteria.

-- Set up a moderately complex backup scenario, created over weeks/months:
INSERT  INTO Minion.BackupSettings
        ( DBName, Port, BackupType, Exclude, GroupOrder, GroupDBOrder, Mirror,
          DelFileBefore, DelFileBeforeAgree, LogLoc, HistRetDays,
          MinionTriggerPath, DBPreCode, DBPostCode, PushToMinion,
          DynamicTuning, Verify, PreferredServer, ShrinkLogOnLogBackup,
          ShrinkLogThresholdInMB, ShrinkLogSizeInMB, MinSizeForDiffInGB,
          DiffReplaceAction, LogProgress, FileAction, FileActionTime, Encrypt,
          Name, ExpireDateInHrs, RetainDays, Descr, Checksum, Init, Format,
          CopyOnly, Skip, BackupErrorMgmt, MediaName, MediaDescription,
          IsActive, Comment )
VALUES  
	--( 'MinionDefault', NULL, 'All', 0, 0, 0, 0, 0, 0, 'Local', 60, NULL,
 --         NULL, NULL, NULL, 1, 0, NULL, 1, 2000, 1024, NULL, NULL, NULL, NULL,
 --         NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL, NULL, NULL,
 --         NULL, 1, NULL ),
        ( 'AdventureWorks', NULL, 'All', 0, 0, 0, 0, 0, 0, 'Local', '60', NULL, NULL,
          NULL, NULL, 1, 0, NULL, 1, '2000', '1024', NULL, NULL, NULL, NULL,
          NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL, NULL, NULL,
          NULL, 1, 'AdventureWorks, All backups' ),
        ( 'Demo', NULL, 'All', 0, 0, 0, 0, 0, 0, 'Local', '60', NULL, NULL,
          NULL, NULL, 1, 0, NULL, 1, '2000', '1024', NULL, NULL, NULL, NULL,
          NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL, NULL, NULL,
          NULL, 1, 'Demo, All backups' ),
        ( 'Demo', NULL, 'Log', 0, 0, 0, 0, 0, 0, 'Local', '60', NULL, NULL,
          NULL, NULL, 1, 0, NULL, 1, '2000', '1024', NULL, NULL, NULL, NULL,
          NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL, NULL, NULL,
          NULL, 1, 'Demo, Log backups' ),
        ( 'Latin1_General_BIN', NULL, 'All', 0, 0, 0, 0, 0, 0, 'Local', '60', NULL,
          NULL, NULL, NULL, 1, 0, NULL, 1, '2000', '1024', NULL, NULL, NULL,
          NULL, NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL, NULL,
          NULL, NULL, 0, 'Latin1_General_BIN, All backups' ),
        ( 'MinionDev', NULL, 'All', 0, 0, 0, 0, 0, 0, 'Local', '60',
          NULL, NULL, NULL, NULL, 1, 0, NULL, 1, '2000', '1024', NULL, NULL,
          NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL,
          NULL, NULL, NULL, 1, 'MinionDev, All backups' ),
        ( 'TDEBackupTest', NULL, 'Full', 0, 0, 0, 0, 0, 0, 'Local', '60', NULL, NULL,
          NULL, NULL, 1, 0, NULL, 1, '2000', '1024', NULL, NULL, NULL, NULL,
          NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL, NULL, NULL,
          NULL, 1, 'TDEBackupTest backups' ),
        ( 'TDEBackupTest', NULL, 'Diff', 0, 0, 0, 0, 0, 0, 'Local', '60', NULL, NULL,
          NULL, NULL, 1, 0, NULL, 1, '2000', '1024', NULL, NULL, NULL, NULL,
          NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL, NULL, NULL,
          NULL, 1, 'TDEBackupTest backups' ),
        ( 'TDEBackupTest', NULL, 'Log', 0, 0, 0, 0, 0, 0, 'Local', '60', NULL, NULL,
          NULL, NULL, 1, 0, NULL, 1, '2000', '1024', NULL, NULL, NULL, NULL,
          NULL, 0, NULL, NULL, NULL, NULL, 1, 1, 1, NULL, NULL, NULL, NULL,
          NULL, 1, 'TDEBackupTest backups' ); 

--!-- NOTE: If DBName/All Exclude = 1, then that trumps DBName/Log Exclude = 0.

SELECT * FROM Minion.BackupSettings;

-- This SP will insert rows as needed, to order log backups.
EXEC Minion.BackupOrderLogBackups
      @Comment = 'Dynamic Ordering'
    , @IReadTheWarning = 1;

SELECT  *
FROM    Minion.BackupSettings
WHERE BackupType = 'Log'
ORDER BY GroupDBOrder DESC;


SELECT * FROM Minion.BackupSettingsServer;


	UPDATE  Minion.BackupSettingsServer
	SET     BatchPreCode = 'EXEC Minion.BackupOrderLogBackups
	@Comment = ''Dynamic Ordering''
	, @IReadTheWarning = 1;'
	WHERE   DBType = 'User'
			AND BackupType = 'Log';

EXEC Minion.BackupMaster @DBType = 'User',
    @BackupType = 'Log', 
    @StmtOnly = 1;
	
-------------------------------------------------
-------------END Dynamic Log Ordering------------
-------------------------------------------------

---------------------------------------------Reset.
DELETE FROM Minion.BackupSettings WHERE DBName <> 'MinionDefault'

UPDATE  Minion.BackupSettingsServer
SET     BatchPreCode = NULL
WHERE   DBType = 'User'
        AND BackupType = 'Log';


------------------------------------------------------------------------------------------															          
------------------------------------------------------------------------------------------
-------------------------------- END Order DBs--------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------															          
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Read Only DBs--------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: Do we back up read only databases along with everything else?  Let's make
--*-- this easier.

-- Later, we'll see how to set up different schedules for read only databases (say, once a
-- month instead of daily or weekly). For now, let's see how we can differentiate with a 
-- call to Minion.BackupMaster.

-- Which databases are read only, anyway?
SELECT  name
      , state_desc
      , is_read_only
FROM    sys.databases
WHERE   is_read_only = 1
        AND source_database_id IS NULL -- eliminates snapshots
ORDER BY name;

SELECT * FROM Minion.BackupSettingsServer; -- See "ReadOnly"

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 1, @Debug = 0 -- All
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 2, @Debug = 0 -- No ROs
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = NULL, @ReadOnly = 3, @Debug = 0 -- Only ROs


------------------------------------------------------------------------------------------															          
------------------------------------------------------------------------------------------
-------------------------------- END Read Only DBs----------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------															          
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Backup Path----------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: Change backup paths easily; not in a dozen jobs!

DELETE Minion.BackupSettingsPath
WHERE ID > 1;
-------------------------------------------------
-------------BEGIN Change All--------------------
-------------------------------------------------
-- A very common scenario is to change backup locations.  Usually this is more 
-- tedious than difficult, but tedium is something we're trying to eliminate.

UPDATE Minion.BackupSettingsPath
SET BackupDrive = 'K:\',
	BackupPath = 'SQLBackups\';

SELECT * FROM Minion.BackupSettingsPath;

Minion.HELP 'backup', 'Minion.BackupSettingsPath'

-- Reset:
UPDATE Minion.BackupSettingsPath
SET BackupDrive = 'C:\',
	BackupPath = 'SQLBackups\';
-------------------------------------------------
-------------END Change All----------------------
-------------------------------------------------


-------------------------------------------------
-------------BEGIN Change Some-------------------
-------------------------------------------------

--This is a very common scenario.  Here you need to back up different DBs to different drives.
--You may even need to send different backup types to different drives.

INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDev' AS [DBName], 0 AS [IsMirror], 'All' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMinionDevALL\' AS [BackupPath], NULL AS [ServerLabel], 24 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'MinionDev All.' AS [Comment]

INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDev' AS [DBName], 0 AS [IsMirror], 'Full' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMinionDevFULL\' AS [BackupPath], NULL AS [ServerLabel], 168 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'MinionDev Full.' AS [Comment]

INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDev' AS [DBName], 0 AS [IsMirror], 'Log' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMinionDevLOG\' AS [BackupPath], NULL AS [ServerLabel], 168 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'MinionDev Log.' AS [Comment]

SELECT * FROM Minion.BackupSettingsPath;

EXEC Minion.BackupStmtGet 'MinionDev', 'Full', 1;
EXEC Minion.BackupStmtGet 'MinionDev', 'Log', 1;

DELETE FROM Minion.BackupSettingsPath
WHERE ID > 1;


-------------------------------------------------
-------------END Change Some---------------------
-------------------------------------------------

------------------------------------------------------------------------------------------															          
------------------------------------------------------------------------------------------
-------------------------------- END Backup Path------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Mirror Backups-------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: Always handle backup paths separately from databases. After all, a single DB can
--*-- be backed up to multiple paths: by mirroring, by striping, and by move/copy. First: mirror!

-- Mirroring backups is quite common, but it does have its issues. We'll address the biggest 
-- issue below in another section.

-- Enable backup mirroring for MinionDev:
INSERT INTO Minion.BackupSettings ( DBName , Port , BackupType , Exclude , GroupOrder , GroupDBOrder , Mirror , DelFileBefore , DelFileBeforeAgree , LogLoc , HistRetDays , MinionTriggerPath , DBPreCode , DBPostCode , PushToMinion , DynamicTuning , Verify , PreferredServer , ShrinkLogOnLogBackup , ShrinkLogThresholdInMB , ShrinkLogSizeInMB , MinSizeForDiffInGB , DiffReplaceAction , LogProgress , FileAction , FileActionTime , Encrypt , Name , ExpireDateInHrs , RetainDays , Descr , Checksum , Init , Format , CopyOnly , Skip , BackupErrorMgmt , MediaName , MediaDescription , IsActive , Comment)
SELECT 'MinionDev' AS DBName , Port , BackupType , Exclude , GroupOrder , GroupDBOrder , Mirror , DelFileBefore , DelFileBeforeAgree , LogLoc , HistRetDays , MinionTriggerPath , DBPreCode , DBPostCode , PushToMinion , DynamicTuning , Verify , PreferredServer , ShrinkLogOnLogBackup , ShrinkLogThresholdInMB , ShrinkLogSizeInMB , MinSizeForDiffInGB , DiffReplaceAction , LogProgress , FileAction , FileActionTime , Encrypt , Name , ExpireDateInHrs , RetainDays , Descr , Checksum , Init , Format , CopyOnly , Skip , BackupErrorMgmt , MediaName , MediaDescription , IsActive , 'MinionDev' Comment
FROM Minion.BackupSettings
WHERE ID = 1;
 
UPDATE Minion.BackupSettings 
SET Mirror = 1
WHERE DBName = 'MinionDev'; 

/*	
	Question: Why ENABLE mirroring, instead of just configuring it?
	Answer: Additional flexibility. We can set up mirror locations, and just turn them off 
			with Mirroring = 0 (instead of all those isActive flags in the Paths table.)
*/

SELECT * FROM Minion.BackupSettings;

-- Set up the backup and backup mirror paths for MinionDev: 
INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [FileName], [FileExtension], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDev' AS [DBName], 0 AS [IsMirror], 'All' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackups\%Server%\%DBName%\' AS [BackupPath], 'MinionDefault' AS [FileName], 'MinionDefault' AS [FileExtension], NULL AS [ServerLabel], 36 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'MinionDev primary' AS [Comment]
UNION
SELECT 'MinionDev' AS [DBName], 1 AS [IsMirror], 'All' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMIRROR\%Server%\%DBName%\' AS [BackupPath], 'MinionDefault' AS [FileName], 'MinionDefault' AS [FileExtension], NULL AS [ServerLabel], 36 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'MinionDev mirror' AS [Comment]


SELECT * FROM Minion.BackupSettingsPath
--(FYI: You can also mirror different DBs and backup types to different locations.)

-- Test the backup mirroring setup:
EXEC Minion.BackupStmtGet 'MinionDev', 'Full', 1

-- RUN the backup mirroring setup:
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'MinionDev', @Exclude = NULL;

SELECT  MirrorBackup
      , *
FROM    Minion.BackupLogDetailsCurrent
ORDER BY ExecutionDateTime DESC;

-- (do not delete)
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Mirror Backups---------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Backup Tuning--------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: Big databases need faster backup and restore. For that, we tune them.
--*-- But DBs also grow; tuning should change dynamically along with them!

-- Tuning backups is an extremely important part of your enterprise maintenance.  
-- Backups that take too long to perform can cause problems.

-- Hey Sean, tell them all about the importance of tuning restores, and RTOs.

-------------------------------------------------
-------------BEGIN General Tuning----------------
-------------------------------------------------

DELETE FROM Minion.BackupTuningThresholds
WHERE ID > 1;

SELECT * FROM Minion.BackupTuningThresholds;

---- ALL
INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 20 AS [ThresholdValue], 4 AS [NumberOfFiles], 100 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'Minion default. DO NOT REMOVE OR CHANGE.' AS [Comment]

INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 50 AS [ThresholdValue], 6 AS [NumberOfFiles], 200 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'Minion default. DO NOT REMOVE OR CHANGE.' AS [Comment]

INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 100 AS [ThresholdValue], 10 AS [NumberOfFiles], 400 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'Minion default. DO NOT REMOVE OR CHANGE.' AS [Comment]

INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 150 AS [ThresholdValue], 15 AS [NumberOfFiles], 500 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'Minion default. DO NOT REMOVE OR CHANGE.' AS [Comment]

SELECT * FROM Minion.BackupTuningThresholds;

EXEC Minion.BackupStmtGet 'MinionDev', 'Full', 125;
EXEC Minion.BackupStmtGet 'DBStats', 'Full', 125;

/* 
	-- IMPORTANT -- 
	Provide yourself a way to test your settings.  
		* Here, BackupStmtGet tests your path and tuning settings.
		* @StmtOnly is there to test ordering settings, and exclusions. 
		* Later, we'll see @TestDateTime, which tests schedule settings.
*/

SELECT * FROM Minion.BackupSettingsPath;
-------------------------------------------------
-------------END General Tuning------------------
-------------------------------------------------


-----Simplify again for the sake of the demo.
UPDATE Minion.BackupSettings 
SET Mirror = 0;


-------------------------------------------------
-------------BEGIN Override Tuning---------------
-------------------------------------------------
--MinionDev
INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 0 AS [ThresholdValue], 1 AS [NumberOfFiles], 0 AS [Buffercount], 0 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'MinionDev All. DO NOT REMOVE OR CHANGE.' AS [Comment]

INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 20 AS [ThresholdValue], 2 AS [NumberOfFiles], 50 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'MinionDev All. 20GB' AS [Comment]

INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 50 AS [ThresholdValue], 4 AS [NumberOfFiles], 100 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'MinionDev All. 50GB' AS [Comment]

INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 100 AS [ThresholdValue], 7 AS [NumberOfFiles], 150 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'MinionDev All. 100GB' AS [Comment]

INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'All' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 150 AS [ThresholdValue], 10 AS [NumberOfFiles], 300 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], NULL AS [BeginTime], NULL AS [EndTime], NULL AS [DayOfWeek], 1 AS [IsActive], 'MinionDev All. 150GB' AS [Comment]

SELECT * FROM Minion.BackupTuningThresholds;

EXEC Minion.BackupStmtGet 'MinionDev', 'Full', 125;
EXEC Minion.BackupStmtGet 'DBStats', 'Full', 125;
EXEC Minion.BackupStmtGet 'DBStats', 'Full', 5;

-- Extra added bonus: MB records the tuning settings chosen for each backup: 
SELECT  *
FROM    Minion.BackupLogDetails
WHERE   DBName = 'DBstats'
        AND BackupType = 'Full';

-------------------------------------------------
-------------END Override Tuning-----------------
-------------------------------------------------



-------------------------------------------------
-------------BEGIN Timed Tuning------------------
-------------------------------------------------
-- SCENARIO: Different settings for different times of day/week.

-- The scenario is that you may be taking different backups throughout the week, or 
-- even throughout the day and the times you're taking the backups may conflict
-- with your business usage.  That's to say that you've tuned your backups to a certain 
-- performance level and the tuning you've set destroys your user performance.
-- So here we're going to define specific busy hours for the business and restrict the 
-- tuning of the backups during those times.
-- This is a scenario that a lot of companies don't even know they have because it's 
-- never really been possible before.  At least not in a reasonable fashion.
-- The functionality is quite rich.
-- Fulls between 12-14.

--Daily
INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'Full' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 150 AS [ThresholdValue], 8 AS [NumberOfFiles], 250 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], '09:00:00' AS [BeginTime], '17:00:00' AS [EndTime], 'Daily' AS [DayOfWeek], 1 AS [IsActive], 'MinionDev Full. Daily. 12-14.' AS [Comment]

--Today
INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'Full' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 150 AS [ThresholdValue], 30 AS [NumberOfFiles], 3000 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], '09:00:00' AS [BeginTime], '17:00:00' AS [EndTime], 'Friday' AS [DayOfWeek], 1 AS [IsActive], 'MinionDev Full. Friday. 12-14.' AS [Comment]

SELECT * FROM Minion.BackupTuningThresholds;

EXEC Minion.BackupStmtGet 'MinionDev', 'Full', 200; 
EXEC Minion.BackupStmtGet 'MinionDev', 'Log', 200;


-- BY THE WAY: If it's a log backup you're tuning, MB is smart enough to go 
-- based on the size of the log.

-------------------------------------------------
-------------END Timed Tuning------------------
-------------------------------------------------


-------------------------------------------------
-------------BEGIN Log Tuning--------------------
-------------------------------------------------
--*-- SCENARIO: Really huge log, backup will throw off the schedule. 
--*-- Dynamically tune log backups so we can get through the log backup FAST.

	-- Again we have a very common scenario that companies just suffer with.
	-- Here the scenario is that you're taking log backups say every 15mins, or every 30mins.  Most of the time all is well,
	-- but from time to time one of the logs gets really big either from a large xact, or maybe the backups have been failing for a while and it didn't get 
	-- noticed right away.  At any rate, one of the logs is much larger than it usually is and this will throw off the backup schedule and the DBs will not be
	-- protected like you think they are.
	   
	-- We've seen this many times in our career.  A set of DBs goes a long time without log backups.  When we looked into it, we found there was a very large log,
	-- say 50GB or 90GB, or even bigger, that was being backed up and taking a long time.  In fact, most people don't bother to tune their log backups so log backups
	-- usually get taken with a single file and the default tuning parameters.  And yes, this can take a very long time.
	   
	-- In scenarios like this, it's always much better to be able to dynamically tune your log backups to help reduce the possibility of these large ones from holding
	-- the rest of your DBs hostage.
	   
	-- Note that the routine is smart enough to use the size of the LOG ITSELF to determine the tuning.  So now instead of taking a 90GB log backup with default params,
	-- you can spread it out to x-files, x-buffers, etc. and then go back to normal settings once the situation is over.

--Daily
INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'Log' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 150 AS [ThresholdValue], 10 AS [NumberOfFiles], 302 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], '09:00:00' AS [BeginTime], '17:00:00' AS [EndTime], 'Daily' AS [DayOfWeek], 1 AS [IsActive], 'MinionDev Full. Daily. 12-14.' AS [Comment]

--Today
INSERT INTO Minion.BackupTuningThresholds ([DBName], [BackupType], [SpaceType], [ThresholdMeasure], [ThresholdValue], [NumberOfFiles], [Buffercount], [MaxTransferSize], [Compression], [BlockSize], [BeginTime], [EndTime], [DayOfWeek], [IsActive], [Comment]) 
SELECT 'MinionDev' AS [DBName], 'Log' AS [BackupType], 'DataAndIndex' AS [SpaceType], 'GB' AS [ThresholdMeasure], 150 AS [ThresholdValue], 30 AS [NumberOfFiles], 3002 AS [Buffercount], 2097152 AS [MaxTransferSize], 1 AS [Compression], 0 AS [BlockSize], '09:00:00' AS [BeginTime], '17:00:00' AS [EndTime], 'Friday' AS [DayOfWeek], 1 AS [IsActive], 'MinionDev Full. Friday. 12-14.' AS [Comment]

EXEC Minion.BackupStmtGet 'MinionDev', 'Full', 200;
EXEC Minion.BackupStmtGet 'MinionDev', 'Log', 200;
EXEC Minion.BackupStmtGet 'MinionDev', 'Log', 10;

SELECT * FROM Minion.BackupTuningThresholds;
--WHERE DBName = 'MinionDev' AND BackupType <> 'Log'

-------------------------------------------------
-------------BEGIN Log Tuning--------------------
-------------------------------------------------

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Backup Tuning--------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Shrinklog------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: Abnormally large log, shrink it after log backup.

	-- Playing off of the theme we were just on, if the log grows abnormally large, we may not 
	-- want the file to stay that big.
	-- There are really 2 scenarios here.
	-- 1. You don't want to have the log choke any of the other log files on the drive and bring the DBs down.
	-- 2. You want to keep the log a reasonable size to keep restore times down.

	-- There has been some critizism for this feature because shrinking logs is considered bad, 
	-- but if your log chokes out other DBs because it has 90GB of unused space, you're going 
	-- to shrink it to get things back on track.  Now we're just arguing over whether you're 
	-- going to get out of bed to do it after it's already caused problems, or have the system 
	-- take care of it before it becomes an issue.

--Grow the log to 2GB
ALTER DATABASE [MinionDev] MODIFY FILE ( NAME = N'MinionDev_log', SIZE = 2048MB )
GO

DBCC SQLPERF(LOGSPACE)

UPDATE Minion.BackupSettings 
SET ShrinkLogOnLogBackup = 1,
	ShrinkLogThresholdInMB = 4096,
	ShrinkLogSizeInMB = 1024;

SELECT * FROM Minion.BackupSettings;

--This one won't shrink.
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Log', @StmtOnly = 0, @Include = 'MinionDev', @Exclude = NULL

DBCC SQLPERF(LOGSPACE);

----Query the log stuff out of the Details
SELECT executionDateTime, DBName, ShrinkLogOnLogBackup, ShrinkLogThresholdInMB, ShrinkLogSizeInMB, 
PreBackupLogSizeInMB, PreBackupLogUsedPct, PostBackupLogSizeInMB, PostBackupLogUsedPct, PreBackupLogReuseWait, PostBackupLogReuseWait, VLFs
FROM Minion.BackupLogDetails
ORDER BY ID DESC;


--Grow the log to 5GB
ALTER DATABASE [MinionDev] MODIFY FILE ( NAME = N'MinionDev_log', SIZE = 5120MB );
GO

--This one WILL shrink.
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Log', @StmtOnly = 0, @Include = 'MinionDev', @Exclude = NULL;

DBCC SQLPERF(LOGSPACE);

----Query the log stuff out of the Details
SELECT executionDateTime, DBName, BackupType, ShrinkLogOnLogBackup, ShrinkLogThresholdInMB, ShrinkLogSizeInMB, 
PreBackupLogSizeInMB, PreBackupLogUsedPct, PostBackupLogSizeInMB, PostBackupLogUsedPct, PreBackupLogReuseWait, PostBackupLogReuseWait, VLFs
FROM Minion.BackupLogDetails
ORDER BY ID DESC;


/*
	Crossing the finish line: If you're running a log backup from a non-primary 
	node of an AG, you can't shrink the log. Non primary nodes are read only! 
	But we detect that in Minion, and connect to the primary node and shrink the 
	log there, and let it trickle down to all the nodes. You'll still get your log 
	shrink, (subject to the AG cooperating).
*/
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Shrinklog------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Copy-----------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: Mirrored backups double your chance of failure. Backup COPIES, though, 
--*-- let you accomplish the same thing without extra risk to the main backup.

-- There are a number of copy scenarios we need to deal with.
-- 1. You need to copy the backup file to a dev/QA box, or even to another data center.
-- 2. You're having network issues with mirrored backups, so you're copying the files instead.  This is more stable cause the backup completes first.
-- 3. You need to copy the files to more than one location on a static schedule. That is, every day.
-- 4. You need to dynamically change the location you're copying the files to.  This could be based off of the day, or even the data center.

----What options are available for copies?
SELECT * FROM Minion.BackupSettingsPath;

EXEC Minion.HELP 'Backup', 'Minion.BackupSettingsPath';

-------------------------------------------------
-------------BEGIN AfterBackup All---------------
-------------------------------------------------
UPDATE Minion.BackupSettings 
SET FileAction = 'Copy', -- Or, Move. Or, CopyAndMove.
	FileActionTime = 'AfterBatch' --AfterBatch
WHERE DBName = 'MinionDefault';

UPDATE Minion.BackupSettings 
SET FileAction = 'Copy',
FileActionTime = 'AfterBackup' --AfterBackup
WHERE DBName = 'MinionDev';

DELETE Minion.BackupSettingsPath
WHERE ID > 1;

--Copy 1
INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [FileName], [FileExtension], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 0 AS [IsMirror], 'Copy' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMinionDefaultCOPY1\%Server%\%DBName%\' AS [BackupPath], 'MinionDefault' AS [FileName], 'MinionDefault' AS [FileExtension], NULL AS [ServerLabel], 48 AS [RetHrs], 'ROBOCOPY' AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'MinionDefault Copy.' AS [Comment]

SELECT * FROM Minion.BackupSettings;
SELECT * FROM Minion.BackupSettingsPath;

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'MinionDev', @Exclude = NULL

SELECT * FROM Minion.BackupFilesCurrent;

--Copy 2
INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [FileName], [FileExtension], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 0 AS [IsMirror], 'Copy' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMinionDefaultCOPY2\%Server%\%DBName%\' AS [BackupPath], 'MinionDefault' AS [FileName], 'MinionDefault' AS [FileExtension], NULL AS [ServerLabel], 24 AS [RetHrs], 'ROBOCOPY' AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'MinionDefault Copy.' AS [Comment]

SELECT * FROM Minion.BackupSettingsPath;


EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'MinionDev', @Exclude = NULL

-------------------------------------------------
-------------END AfterBackup All-----------------
-------------------------------------------------



-------------------------------------------------
-------------BEGIN AfterBatch All---------------
-------------------------------------------------

UPDATE Minion.BackupSettings 
SET FileAction = 'Copy',
FileActionTime = 'AfterBatch' --AfterBackup

DELETE Minion.BackupSettingsPath
WHERE ID > 1;

--Copy 1
INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 0 AS [IsMirror], 'Copy' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMinionDefaultCOPY1\%Server%\%DBName%\' AS [BackupPath], NULL AS [ServerLabel], 48 AS [RetHrs], 'ROBOCOPY' AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'MinionDefault Copy.' AS [Comment]

SELECT * FROM Minion.BackupSettingsPath

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'Minion,MinionRestore,AdventureWorks,MalMRIssues,MRIssueRepro,MinionDev', @Exclude = NULL


/*	
	---- Turn on agent!! ----

	--- Watch the backups as they come across,
	--- and watch the copy happen after batch:

	SELECT  DBName
		  , STATUS
		  , PctComplete
		  , BackupStartDateTime
		  , BackupEndDateTime
		  , FileAction
		  , FileActionTime
		  , FileActionBeginDateTime
		  , FileActionEndDateTime
	FROM    Minion.BackupLogDetailsCurrent
	ORDER BY ID DESC;
	
*/

-------------------------------------------------
-------------END AfterBatch All-----------------
-------------------------------------------------


------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Copy-------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN ServerLabel----------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: DR setup, backups will go to different folders depending on what server 
--*-- they're on. 
--*-- Let's fix it!

	-- Let's say we have a DR scenario with 2 locations. Maybe it's mirroring, maybe log shipping, maybe an AG.
	-- A mirrored pair, or log shipped pair, or set of AG servers...each of these is ONE scenario. So treat
	-- it like one scenario!

	-- \\xyz1\sqlbackups\servername\dbname\			-- lame
	-- \\xyz1\sqlbackups\serverlabel\dbname\		-- good!
 
	-- In any case, there's the potential for our database to end up on another server, with another server name.   
	-- THAT MEANS that if DB1 is on Server1, backups going to \\nas\Server1\DB1\, things will change after failover.
	-- once we fail over to Server2, we'll have DB1 backups on \\nas\Server2\DB1\. That is no bueno! I want 
	-- all my backups in one place!
   
	-- How about, no matter what server we're on, DB1 backups should go to \\nas\SQLServer\DB1\.  
   
-- Enter: ServerLabel!! 


UPDATE  Minion.BackupSettingsPath
SET     ServerLabel = 'MinionDev.MinionWare.NET'
      , BackupPath = 'SQLBackupsMinionDefaultCOPY1\%SoSL%\%DBName%\'
WHERE   BackupPath LIKE 'SQLBackupsMinionDefaultCOPY1\%';

SELECT * FROM Minion.BackupSettingsPath;

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'MinionDev', @Exclude = NULL;


SELECT * FROM Minion.BackupFilesCurrent;

---- Cleanup:
UPDATE Minion.BackupSettings SET FileAction=NULL, FileActionTime=NULL;
DELETE Minion.BackupSettingsPath WHERE ID > 1;
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END ServerLabel------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN DataCenter-----------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: We have a DR scenario (mirroring, or log shipping, or an AG) where the DB 
--*-- could fail over to another sever. Maybe that server needs a different backup location.
--*-- AUTOMATE!

-- Set up one path to use on the primary server, and one (inactive) on the secondary server:
INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MBDemo' AS [DBName], 0 AS [IsMirror], 'All' AS [BackupType], 'NAS' AS [BackupLocType], '\\DRserver1\' AS [BackupDrive], 'SQLBackupsMBDemoALL\' AS [BackupPath], NULL AS [ServerLabel], 48 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 0 AS [IsActive], NULL AS [AzureCredential], 'DR site: MBDemo All.' AS [Comment]

INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MBDemo' AS [DBName], 0 AS [IsMirror], 'All' AS [BackupType], 'local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMBDemoALL\' AS [BackupPath], NULL AS [ServerLabel], 48 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'ProdSvr: MBDemo All.' AS [Comment]

SELECT * FROM Minion.BackupSettingsPath;

-- Use the following as batch precode for Minion.BackupSettingsServer:
    EXEC Minion.BackupUpdatePathByServer 
		@PrimaryServer = 'ProdSvr',
        @DBName = 'MBDemo';

SELECT * FROM Minion.BackupSettingsPath;

------------------------------------Reset.
UPDATE Minion.BackupSettings 
SET FileAction = NULL,
FileActionTime = NULL;

DELETE Minion.BackupSettingsPath WHERE DBName='MBDemo';

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END DataCenter-------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Certs----------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: If you have certificates, back them up! (Often badly overlooked.)

-- What server certificates do we have: 
SELECT * FROM master.sys.certificates WHERE name NOT LIKE '##%';

-- Start fresh for this demo:
TRUNCATE TABLE Minion.BackupCert;

SELECT * FROM Minion.BackupCert;

-------------------------------------------------
-------------BEGIN Set up cert backup------------
-------------------------------------------------
-- Insert a row for CertType=ServerCert:
INSERT Minion.BackupCert (CertType, CertPword, BackupCert)
SELECT 'ServerCert', Minion.EncryptTxt ('ThisIsAGoodPword!!!111!!!'), 1

SELECT * FROM Minion.BackupCert;

----Set up ServerCert backup path(s). Note: DBName doesn't matter.
INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [FileName], [FileExtension], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 0 AS [IsMirror], 'ServerCert' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMinionDefaultServerCERT1\' AS [BackupPath], '%CertName%_%Date%_%Time%' AS [FileName], '%ServerCertExtension%' AS [FileExtension], NULL AS [ServerLabel], 2016 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'ServerCert.' AS [Comment]

SELECT * FROM Minion.BackupSettingsPath;

-- Server certificates are backed up along with master.
EXEC Minion.BackupMaster @DBType = 'System', @BackupType = 'Full', @StmtOnly = 0, @Include = 'master', @Exclude = NULL;

SELECT * FROM Minion.BackupFilesCurrent;

---- You can back up to multiple locations, just by adding another path:
INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [FileName], [FileExtension], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 0 AS [IsMirror], 'ServerCert' AS [BackupType], 'Local' AS [BackupLocType], 'C:\' AS [BackupDrive], 'SQLBackupsMinionDefaultServerCERT2\' AS [BackupPath], '%CertName%_%Date%_%Time%' AS [FileName], '%ServerCertExtension%' AS [FileExtension], NULL AS [ServerLabel], 2016 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'ServerCert.' AS [Comment]

EXEC Minion.BackupMaster @DBType = 'System', @BackupType = 'Full', @StmtOnly = 0, @Include = NULL, @Exclude = NULL;



-------------------------------------------------
-------------END Set up cert backup--------------
-------------------------------------------------

-- SELECT  * FROM Minion.BackupLogDetailsCurrent;

-------------------------------------------------
-------------BEGIN See cert backup failure-------
-------------------------------------------------

----Now let's see what a failure looks like.
INSERT INTO Minion.BackupSettingsPath ([DBName], [IsMirror], [BackupType], [BackupLocType], [BackupDrive], [BackupPath], [FileName], [FileExtension], [ServerLabel], [RetHrs], [FileActionMethod], [FileActionMethodFlags], [PathOrder], [IsActive], [AzureCredential], [Comment]) 
SELECT 'MinionDefault' AS [DBName], 0 AS [IsMirror], 'ServerCert' AS [BackupType], 'Local' AS [BackupLocType], '\\MinionDevcon\KB\' AS [BackupDrive], 'CertBackups\' AS [BackupPath], '%CertName%_%Date%_%Time%' AS [FileName], '%ServerCertExtension%' AS [FileExtension], NULL AS [ServerLabel], 2016 AS [RetHrs], NULL AS [FileActionMethod], NULL AS [FileActionMethodFlags], 0 AS [PathOrder], 1 AS [IsActive], NULL AS [AzureCredential], 'ServerCert.' AS [Comment]

EXEC Minion.BackupMaster @DBType = 'System', @BackupType = 'Full', @StmtOnly = 0, @Include = 'master', @Exclude = NULL

SELECT * FROM minion.BackupLogDetailsCurrent;
	-- NOTE: The system's main job is to back up databases; 
	-- a failed cert backup gets a warning, not an error.


------Force a backup error; it looks different from a cert backup failure:
UPDATE Minion.BackupSettingsPath
SET BackupDrive = 'CD:\'
WHERE DBName = 'MinionDefault' AND BackupType = 'All';

SELECT * FROM Minion.BackupSettingsPath;

EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'Demo, Minion', @Exclude = NULL
SELECT * FROM Minion.BackupLogCurrent;
SELECT * FROM Minion.BackupLogDetailsCurrent;

-------------------------------------------------
-------------END See cert backup failure---------
-------------------------------------------------

-- Cleanup
UPDATE Minion.BackupSettingsPath
SET BackupDrive='C:\';

DELETE Minion.BackupSettingsPath
WHERE ID > 1;

SELECT * FROM Minion.BackupSettingsPath

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Certs------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Missing--------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: Backups just fail. Now what? Catch the failed backups!

	--Here's another scenario that companies just put up with.
	--Periodically, backups just fail.  Whether it be for a lack of space, or network or server issues, etc., you still have to 
	--retake the backups.  So far your choices are to have a NOC wake you up, or restart them when you get in.
	--However, by the time you come in it may be too late because the business day has already started and you can't afford to drag down the system.
	--As well, you could throw off your deletion schedule drastically.  That's why it's usually decided to just let the log backups roll and not make-up the
	--missing full backup.

/*
We're going to set this up by creating a bad path for a specific DB.
Then run a group of backups and watch that 1 fail.
Then run with Missing so we can watch it get picked up.
*/
-- By default, MB comes with a disabled scenario for Missing backups:
SELECT * FROM Minion.BackupSettingsServer WHERE Include='Missing';

----------------BEGIN SETUP----------------------
INSERT Minion.BackupSettingsPath
        (DBName, IsMirror, BackupType, BackupLocType, BackupDrive, BackupPath, [FileName],[FileExtension],
         ServerLabel, RetHrs, FileActionMethod, FileActionMethodFlags,
         PathOrder, IsActive, AzureCredential, Comment)
SELECT N'CDC', 0, 'All', 'Local', 'K:\', 'SQLBackups\', 'MinionDefault', 'MinionDefault', NULL, 24, NULL, NULL, 0, 1, NULL, 'Minion default. DO NOT REMOVE OR CHANGE.'

SELECT * FROM Minion.BackupSettingsPath
----------------END SETUP------------------------


------------------BEGIN 1st demo-----------------

--This should have 1 failed backup because of the bad path setup above.
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'TDEBackupTest,JenDemo,CDC,BobTest', @Exclude = NULL

SELECT  *
FROM    Minion.BackupLogDetailsCurrent;
------------------END 1st demo-------------------


------------------BEGIN 2nd demo-----------------
-- Let's fix the problem.
UPDATE Minion.BackupSettingsPath
SET BackupDrive='C:\'


--This should have 1 failed backup because of the bad path setup above.
--@Include='Missing' checks the last batch OF THIS TYPE (here, User/Full) for backups that didn't complete.
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'Missing', @Exclude = NULL;

SELECT  *
FROM    Minion.BackupLogDetailsCurrent;


------------------END 2nd demo-------------------

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Missing----------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Live Insight---------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- SCENARIO: Backups are running long. Is it stuck? Is it progressing? Let's see.


--Only run this if you need to reset the entire demo.
----TRUNCATE TABLE Minion.BackupLog
----TRUNCATE TABLE Minion.BackupLogDetails
----TRUNCATE TABLE Minion.BackupFiles

---Watch the progress of this DB as it backs up.
---Open a new window for the Status.
SELECT * FROM Minion.BackupLogCurrent;

SELECT * FROM Minion.BackupLogDetailsCurrent;

SELECT * FROM Minion.BackupFilesCurrent;


EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 0, @Include = 'Minion, MinionRestore', @Exclude = NULL

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Live Insight-----------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- BEGIN Scheduler------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: You want flexible backup schedule options. If nothing else, you want to 
--*-- manage your schedules in a table, not with multiple SQL Agent jobs.

-- Let's look at the schedule table: BackupSettingsServer!

---------------------------------------------
-----------BEGIN Initial Load----------------
---------------------------------------------
TRUNCATE TABLE Minion.BackupSettingsServer;

-- Minion.HELP 'backup', 'Minion.BackupSettingsServer'

INSERT INTO Minion.BackupSettingsServer
VALUES
('System', 'Full', 'Daily', 1, '22:00:00', '22:30:00', 1, NULL, 0, NULL, N'2016-04-05 22:00:00.847', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 1, 'Daily System Backups' ), 
('User', 'Full', 'Daily', 2, '23:00:00', '23:30:00', 1, NULL, 0, NULL, N'2015-09-04 13:44:22.097', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 1, 'Weekly Full Backups' ), 
('User', 'Diff', 'Weekday', 1, '06:00:00', '23:00:00', 6, 240, 0, NULL, N'2016-04-06 19:30:00.280', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 1, 'Daily Diff Backups' ), 
('User', 'Diff', 'Sunday', 1, '23:00:00', '23:00:00', 1, NULL, 0, NULL, N'2015-05-17 23:30:00.107', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 1, 'Sunday Diff Backups' ), 
('User', 'Log', 'Daily', 1, '00:00:00', '23:59:00', 300, 15, 0, NULL, N'2016-04-05 23:30:01.810', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 1, 'Log Backups Multi-day' ), 
('User', 'Full', 'Daily', 2, '02:00:00', '05:30:00', 1, NULL, 0, NULL, NULL, 'Missing', NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 0, 'Missing Backups' ), 
('User', 'Full', 'LastOfMonth', 1, '23:00:00', '23:30:00', 1, NULL, 0, NULL, N'2015-09-04 13:44:22.097', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 1, 'End of Month Full Backups including RO DBs' ),
('User', 'Full', 'FirstOfMonth', 2, '23:00:00', '23:30:00', 1, NULL, 0, NULL, N'2015-09-04 13:44:22.097', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, 1, 'First of Month Full Backups including RO DBs' )

-- Nnote the BeginTime/EndTime range that allows a backup to start 
-- WITHIN A WINDOW OF TIME, instead of a specific time.
SELECT * FROM Minion.BackupSettingsServer
WHERE isactive=1
ORDER BY DBType, BackupType, DAY, BeginTime;

-- Notice the end of month full backup, that includes Read Only databases. Neato burrito!
SELECT * FROM Minion.BackupSettingsServer
WHERE isactive=1 AND BackupType = 'Full' AND DBType = 'User'
ORDER BY DBType, BackupType, DAY, BeginTime;


	--*-- BONUS: BackupMaster has a @TestDateTime param: test what schedule will be used!

------Normal Daily run.
DECLARE @NormalDay DATETIME = '10/15/2016 23:00:00';	-- SELECT DATEPART(dw, @NormalDay) --  Saturday;
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = NULL, @StmtOnly = 1, @Include = NULL, @Exclude = NULL,
	@TestDateTime = @NormalDay; -- Note: BackupType must be null, to use the scheduler table.

------FoM
DECLARE @FirstOfMonth DATETIME = '10/1/2016 23:00:00';
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = NULL, @StmtOnly = 1, @Include = NULL, @Exclude = NULL,
	@TestDateTime = @FirstOfMonth; -- Note: BackupType must be null, to use the scheduler table.

------LoM
DECLARE @LastOfMonth DATETIME = '10/31/2016 23:00:00';
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = NULL, @StmtOnly = 1, @Include = NULL, @Exclude = NULL,
	@TestDateTime = @LastOfMonth; -- Note: BackupType must be null, to use the scheduler table.


---------------------------------------------
-----------END Initial Load------------------
---------------------------------------------


SELECT * FROM Minion.BackupSettingsServer;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Scheduler------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------


------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Grouping DBs-----------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*-- SCENARIO: Easily group DBs for backups.

--You've got a lot of DBs on your server and you need to back some of them up in the same batch.
--Perhaps they're part of the same app... 

TRUNCATE TABLE [Minion].[DBMaintDBGroups];

INSERT [Minion].[DBMaintDBGroups] ([Action], MaintType, GroupName, GroupDef, [ESCAPE], IsActive, Comment)
VALUES
('Include', 'Backup', 'DW', 'D%', NULL, 1, 'All D% DBs.'), 
('Include', 'Backup', 'DW', 'MB%', NULL, 1, 'All MB% DBs.'),
('Exclude', 'Backup', 'DW', 'D%', NULL, 1, 'All D% DBs.'), 
('Exclude', 'Backup', 'DW', 'MB%', NULL, 1, 'All MB% DBs.')

SELECT * FROM [Minion].[DBMaintDBGroups];

----Include the Group.
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = 'DBGroup:DW', @Exclude = NULL, @ReadOnly = 1, @Debug = 0

----Exclude the Group!
EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', @StmtOnly = 1, @Include = NULL, @Exclude = 'DBGroup:DW', @ReadOnly = 1, @Debug = 0



------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-------------------------------- END Grouping DBs-----------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------


 --------------------------------------------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------------------------------------------
 ------------------------------------------------BEGIN HA Scenarios--------------------------------------------------------------
 --------------------------------------------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------------------------------------------


 /* And now, the Data Waiter!! */
 -------------------------------------------------------------
 -------------------------------------------------------------
 -------------BEGIN HA Sync Settings--------------------------
 -------------------------------------------------------------
 -------------------------------------------------------------
 --*-- SCENARIO: Manage changes to backup settings across HA nodes; 
 --*-- this is usually cumbersome and error prone.
 
 ---- Here we're going to have MB push the settings changes to each node so 
 ---- we don't have to manage it, and all nodes are automatically updated 
 ---- WITH the latest info.

 
EXEC Minion.HELP 'backup', 'Minion.SyncServer';
EXEC Minion.HELP 'backup', 'How to: Synchronize backup settings and logs among instances'
	/*
	The basic steps to configure the Data Waiter are: 
	  1. Install Minion Backup on each destination instance. [Done!]
	  2. Configure the synchronization partners in the Minion.SyncServer table.
	  3. Enable the Data Waiter for settings and/or logs, in the Minion.BackupSettingsServer table.
	  4. Run the Minion.BackupSyncSettings procedure, to prepare a snapshot of settings data.
	  5. Run Minion.SyncPush to initialize the servers.
	*/


USE PRECONDBMaint;
GO
--Setup
TRUNCATE TABLE Minion.SyncServer;
TRUNCATE TABLE Minion.SyncCmds	
TRUNCATE TABLE Minion.SyncErrorCmds

---- Hey look, we have settings we want to share to the other node(s)!
SELECT * FROM Minion.BackupCert
SELECT * FROM Minion.BackupSettings;
SELECT * FROM Minion.BackupSettingsPath;
SELECT * FROM Minion.BackupTuningThresholds;
SELECT * FROM Minion.BackupSettingsServer;

---- Let's pretend that this is the second AG node, okay guys? 
USE PRECONDataWaiterPartner;
GO

TRUNCATE TABLE Minion.BackupCert;
TRUNCATE TABLE [Minion].[BackupTuningThresholds];
TRUNCATE TABLE [Minion].[BackupSettings];
TRUNCATE TABLE [Minion].[BackupSettingsPath];
TRUNCATE TABLE Minion.BackupSettingsServer;

SELECT * FROM Minion.BackupCert;
SELECT * FROM [Minion].[BackupTuningThresholds];
SELECT * FROM [Minion].[BackupSettings];
SELECT * FROM [Minion].[BackupSettingsPath];
SELECT * FROM Minion.BackupSettingsServer;


-----------------------------------------------------------------------------------
---- 2. Configure the synchronization partners in the Minion.SyncServer table. ----
-----------------------------------------------------------------------------------
---- Set up the synchronization settings (from here to 'PRECONDataWaiterPartner'): 
USE PRECONDBMaint;
GO
INSERT  INTO Minion.SyncServer
        ( Module
        , DBName
        , SyncServerName
        , SyncDBName
        , Port
        , ConnectionTimeoutInSecs
        )
VALUES  ( 'backup'
        , 'PRECONDBMaint'
        , 'bendycon'	--!-- Can be a single server, or a pipe delimited list, or 'AGReplica', or 'MirroringPartner', or 'LogShippingPartner'
        , 'PRECONDataWaiterPartner'
        , NULL
        , 30
        );

SELECT  * FROM    Minion.SyncServer;

-----------------------------------------------------------------------------------
---- 3. Enable the Data Waiter for settings and/or logs, in the Minion.BackupSettingsServer table. ----
-----------------------------------------------------------------------------------
IF 1=2
	UPDATE  Minion.BackupSettingsServer
	SET     SyncSettings = 1
		  , SyncLogs = 1;

-- (Actually, for this demo we'll be using the parameters @SyncSettings = 1, @SyncLogs = 1;
IF 1=2 -- Don't run this yet!
	EXEC Minion.BackupMaster @DBType = 'User', @BackupType = 'Full', 
		@StmtOnly = 0, @Include = 'DBStats', @Exclude = NULL, @ReadOnly = 1, @Debug = 0,
		@SyncSettings = 1, @SyncLogs = 1; 

-----------------------------------------------------------------------------------
---- 4. Run the Minion.BackupSyncSettings procedure, to prepare a snapshot of settings data. ----
-----------------------------------------------------------------------------------
---- Now sync the settings. We're running this manually for now, for the demo. 
---- Normally, this is only called from master.
EXEC Minion.BackupSyncSettings;

SELECT * FROM Minion.SyncCmds;	 -- Now we have the commands to be shared out to other node(s).

-----------------------------------------------------------------------------------
---- 5. Run Minion.SyncPush to initialize the servers.	
-----------------------------------------------------------------------------------
EXEC Minion.SyncPushDEMO @Tables='Settings', @Process='All', @Module='Backup'; 

 	--EXEC Minion.BackupMaster 'User', 'Full', 0, 'DBStats', NULL;


----Check that they made it to the other DB like they were supposed to.
USE PRECONDataWaiterPartner;
GO
SELECT * FROM Minion.BackupCert;
SELECT * FROM [Minion].[BackupTuningThresholds];
SELECT * FROM [Minion].[BackupSettings];
SELECT * FROM [Minion].[BackupSettingsPath];
SELECT * FROM [Minion].[BackupSettingsServer];


 USE PRECONDBMaint;
 GO

----Let's take a look at it more in depth because tshooting is also part of the lifecycle.
EXEC Minion.BackupSyncSettings;

--Notice the Status of either Complete or In queue. And the Pushed col.
select * from Minion.SyncCmds ORDER BY ID

 -------------------------------------------------------------
 -------------------------------------------------------------
 -------------END HA Sync Settings----------------------------
 -------------------------------------------------------------
 -------------------------------------------------------------



-------------------------------------------------------------
-------------------------------------------------------------
-------------BEGIN HA Sync Logs------------------------------
-------------------------------------------------------------
-------------------------------------------------------------
USE PRECONDBMaint;
GO
--Setup.
TRUNCATE TABLE Minion.SyncCmds;
TRUNCATE TABLE Minion.SyncErrorCmds;

-- Hey look, we have log data we want to share to the other node(s)!
	SELECT * FROM minion.BackupLog
	ORDER BY ID DESC;
	SELECT * FROM minion.BackupLogDetails
	ORDER BY ID DESC;
	SELECT * FROM minion.backupFiles
	ORDER BY ID DESC;

--- Our SyncServer settings are already configured, from the last example:
SELECT * FROM Minion.SyncServer;


--- Syncing logs: Specify a particular datetime (from a batch) to sync that particular batch.
EXEC Minion.BackupSyncLogs '2016-11-08 11:01:43.303';  -- SELECT * FROM Minion.BackupLogCurrent

SELECT * FROM Minion.SyncCmds; -- Commands to sync.

-- Actually pushes the commands to the other server(s)
EXEC Minion.SyncPushDEMO @Tables='Logs', @Process='All', @Module='Backup'; 


----Check that they made it to the other DB like they were supposed to.
USE PRECONDataWaiterPartner;
GO
	SELECT * FROM minion.BackupLog
	ORDER BY ID DESC;
	SELECT * FROM minion.BackupLogDetails
	ORDER BY ID DESC;
	SELECT * FROM minion.backupFiles
	ORDER BY ID DESC;

------------------------------------------------------------
---- IMPORTANT: All of this was a manual demo. But, you must be able to sync settings and logs automatically.
---- In MB, that's done with: 
----		EXEC Minion.BackupMaster ... @SyncSettings = 1, @SyncLogs = 1 ...
------------------------------------------------------------

-- Any errors go here:
SELECT * FROM [Minion].[SyncErrorCmds];

 -------------------------------------------------------------
 -------------------------------------------------------------
 -------------END HA Sync Logs------------------------------
 -------------------------------------------------------------
 -------------------------------------------------------------

 --------------------------------------------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------------------------------------------
 ------------------------------------------------END HA Scenarios----------------------------------------------------------------
 --------------------------------------------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------------------------------------------


/*
---- Cleanup: 
IF EXISTS (select count(*) from Minion.BackupSettings WHERE ID = 1)
	DELETE FROM Minion.BackupSettings WHERE ID > 1;

IF EXISTS  (select count(*) from Minion.BackupSettingsPath WHERE ID = 1)
	DELETE FROM Minion.BackupSettingsPath WHERE ID > 1;

IF EXISTS  (select count(*) from Minion.BackupTuningThresholds WHERE ID = 1)
	DELETE FROM Minion.BackupTuningThresholds WHERE ID > 1;

IF 6 = (select count(*) from Minion.BackupSettingsServer WHERE ID <= 6)
	DELETE FROM Minion.BackupSettingsServer WHERE ID > 6;
*/


